<?php
/**
 * Copyright ©  All rights reserved.
 * See COPYING.txt for license details.
 */
declare(strict_types=1);

namespace Pinpoint\CarouselManager\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface SlideCtaRepositoryInterface
{

    /**
     * Save SlideCta
     * @param \Pinpoint\CarouselManager\Api\Data\SlideCtaInterface $slideCta
     * @return \Pinpoint\CarouselManager\Api\Data\SlideCtaInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \Pinpoint\CarouselManager\Api\Data\SlideCtaInterface $slideCta
    );

    /**
     * Retrieve SlideCta
     * @param string $slidectaId
     * @return \Pinpoint\CarouselManager\Api\Data\SlideCtaInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($slidectaId);

    /**
     * Retrieve SlideCta matching the specified criteria.
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Pinpoint\CarouselManager\Api\Data\SlideCtaSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete SlideCta
     * @param \Pinpoint\CarouselManager\Api\Data\SlideCtaInterface $slideCta
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \Pinpoint\CarouselManager\Api\Data\SlideCtaInterface $slideCta
    );

    /**
     * Delete SlideCta by ID
     * @param string $slidectaId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($slidectaId);
}

